Best Time to Buy and Sell Stock with Transaction Fee

LeetCode Q 714 - Best Time to Buy and Sell Stock with Transaction Fee

Your are given an array of integers prices, for which the i-th element is the price of a given stock on day i; and a non-negative integer fee representing a transaction fee.
You may complete as many transactions as you like, but you need to pay the transaction fee for each transaction. You may not buy more than 1 share of a stock at a time (ie. you must sell the stock share before you buy again.)
Return the maximum profit you can make.

Example 1:
Input: prices = [1, 3, 2, 8, 4, 9], fee = 2 ; Output: 8
Explanation: The maximum profit can be achieved by:

  • Buying at prices[0] = 1
  • Selling at prices[3] = 8
  • Buying at prices[4] = 4
  • Selling at prices[5] = 9
    The total profit is ((8 - 1) - 2) + ((9 - 4) - 2) = 8.

Note:

  • 0 < prices.length <= 50000.
  • 0 < prices[i] < 50000.
  • 0 <= fee < 50000.

Solution :

Solution: traditional DP

We use two arrays to store the states.

  1. buy[i]: it represents we end with a buy action at day k (k <= i).
  2. sell[i]: it represents we end with a sell action at day k (k <= i).

Time Complexity: O(n)
Space Complexity: O(2n) -> O(n)

Code:

public int maxProfit(int[] prices, int fee) {
	if (prices == null || prices.length == 0)
		return 0;
	int[] buy = new int[prices.length];
	int[] sell = new int[prices.length];
	buy[0] = -prices[0];
	for (int i = 1; i < prices.length; i++) {
		buy[i] = Math.max(buy[i - 1], -prices[i] + sell[i - 1]);
		sell[i] = Math.max(sell[i - 1], prices[i] + buy[i] - fee);
	}
	return sell[prices.length - 1];
}

Solution: DP Optimized Space

Since buy[i] and sell[i] only depends on buy[i - 1] and sell[i - 1] respectively, instead of using arrays we can just use to vars to store the states, which optimizing the space complecity to be O(1).

Code:

public int maxProfit(int[] prices, int fee) {
	if (prices == null || prices.length == 0)
		return 0;
	int buy = -prices[0];
	for (int i = 1; i < prices.length; i++) {
		buy = Math.max(buy, sell - prices[i]);
		sell = Math.max(sell, prices[i] + buy - fee);
	}
	return sell;
}

   Reprint policy


《Best Time to Buy and Sell Stock with Transaction Fee》 by Tong Shi is licensed under a Creative Commons Attribution 4.0 International License
 Previous
Palindromic Substrings Palindromic Substrings
LeetCode Q 647 - Palindromic SubstringsGiven a string, your task is to count how many palindromic substrings in this str
2019-04-24 Tong Shi
Next 
Counting Bits Counting Bits
LeetCode Q 338 - Counting BitsGiven a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calc
2019-04-24 Tong Shi
  TOC